/**********************************************************************\
**
**                         Copyright (c) 2007-2017 by
**                          HENGSTLER GmbH, Aldingen
**
**      This  software  is furnished under a license and may be used and
**      copied only in accordance with the terms  of  such  license  and
**      with the inclusion of the above copyright notice.  This software
**      or any other copies thereof may not  be  provided  or  otherwise
**      made  available  to any other person.  No title to and ownership
**      of the software is hereby transferred.
**
**      The  information  in  this software is subject to change without
**      notice and should not be construed as a commitment by Hengstler.
**
**  Module:      Exo-Pmpt-DlgMain.h
**  Facility:    S684015 - Hengstler Extendo Printer Driver for Windows XP/7/8/10 
**  Component:   Extendo print monitor plugin test tool (Exo_PrintMonPluginTest)
**  Version:     R7-V2.03-FINAL / 2017APR20
**  Environment: Microsoft Windows XP/7/8/10
**  Compiler:    Microsoft Visual C++ .NET   
**  Abstract:    Header file of module Exo-Pmpt-DlgMain.cpp
**  Note:        -
**  History:     R1-V1.00 / 2007DEC21 / HOR / 1ST RELEASE 
**               -----------------------------------------------------
**               R2-V1.01 / 2008MAY31 / HOR / 2ND RELEASE 
**               -----------------------------------------------------
**               R3-V1.02 / 2010APR30 / HOR / 3RD RELEASE
**               -----------------------------------------------------
**               R4-V2.00a  / 2011MAY26 / HOR / M-R4-004-HOR
**                  Complete printer package ported to VS2010, reviewed and adapted Windows 7 32+64 bit
**               R4-V2.00 / 2013JUL18 / HOR / 4TH RELEASE
**               -----------------------------------------------------
**               R5-V2.01 / 2015MAY07 / HOR / 5TH RELEASE
**               -----------------------------------------------------
**               R6-V2.02b / 2016MAY25 / HOR / M-R6-007-HOR
**                  Driver package ported to VS2015 and adapted to Windows 10.
**               R6-V2.02 / 2016MAY25 / HOR / 6TH RELEASE
**               -----------------------------------------------------
**               R7-V2.03 / 2017APR20 / HOR / 7TH RELEASE
**               -----------------------------------------------------
**
\**********************************************************************/

#ifndef __EXO_PMPT_DLGMAIN_H
#define __EXO_PMPT_DLGMAIN_H

/*
** COMPILER
*/

#pragma once


/*
** INCLUDES
*/

#include "Exo_PrintMonPlugin.h"

/*
** COMPILER 
*/

/*
** MACROS
*/

/*
** TYPES
*/

/*
** CLASSES
*/

class CExo_Pmpt_DlgMain : public CDialog
{
   public:

      //-- Constructor/destructor
      CExo_Pmpt_DlgMain                                     (CWnd* pParent = NULL);
      ~CExo_Pmpt_DlgMain                                    ();


      //-- Identifier of corresponding resource
      enum                { IDD = IDD_DLG_MAIN };

   protected:

      //-- DDX/DDV support
      virtual void        DoDataExchange                    (CDataExchange* pDX);   

      //-- Local icon of dialog
      HICON               m_hIconL;                        // Handle of large icon 
      HICON               m_hIconS;                        // Handle of small icon
  
      //-- Dialog overwrites
      virtual BOOL        OnInitDialog                      ();

      //-- AFX messages
      afx_msg void        OnSysCommand                      (UINT nID, LPARAM lParam);
      afx_msg void        OnPaint                           ();
      afx_msg HCURSOR     OnQueryDragIcon                   ();
      afx_msg void        OnTimer                           (UINT nIDEvent);
 
      //-- Declare message map
      DECLARE_MESSAGE_MAP()

   private:
   
      //-- Methods for reading data from registry 
      bool               ReadPrinterDataFromRegistry        (PSTR pszPrinter, PSTR pszKey, PSTR pszValue, PBYTE pubData, DWORD dwSize);

      //-- Methods for updating the dialog 
      void               UpdateDialog                       ();
      void               UpdateJobInfoInDialog              (PS_EXO_PMP_JOB_INFO psJobInfo);
      void               UpdatePrinterInfoInDialog          (PS_EXO_PMP_PRINTER_INFO psPrinterInfo);
      void               UpdatePrinterStatusInDialog        (PS_EXO_PMP_PRINTER_STATUS psPrinterStatus);

      //-- Member variables
      UINT_PTR           m_iTimer;                          // Timer for periodical update
      PSTR               m_pszPrinter;                      // Selected printer

public:
   afx_msg void OnCbnSelchangeComboPrinterDriver();
};

/*
** VARIABLES
*/

#endif